## rustc 1.41.1%2Bdfsg1

=== src/test/run-make-fulldeps/issue-37893/Makefile ===
-include ../tools.mk

# ignore-stage1

all:
	$(RUSTC) a.rs && $(RUSTC) b.rs && $(RUSTC) c.rs

=== src/test/run-make-fulldeps/sanitizer-dylib-link/Makefile ===
# needs-sanitizer-support
# only-x86_64
# only-linux

-include ../tools.mk

LOG := $(TMPDIR)/log.txt

# This test builds a shared object, then an executable that links it as a native
# rust library (contrast to an rlib). The shared library and executable both
# are compiled with address sanitizer, and we assert that a fault in the dylib
# is correctly detected.

# See comment in sanitizer-address/Makefile for why this is here
EXTRA_RUSTFLAG=-C relocation-model=dynamic-no-pic

all:
	$(RUSTC) -g -Z sanitizer=address --crate-type dylib --target $(TARGET) $(EXTRA_RUSTFLAG) library.rs
	$(RUSTC) -g -Z sanitizer=address --crate-type bin --target $(TARGET) $(EXTRA_RUSTFLAG) -llibrary program.rs
	LD_LIBRARY_PATH=$(TMPDIR) $(TMPDIR)/program 2>&1 | $(CGREP) stack-buffer-overflow

=== src/test/run-make/wasm-stringify-ints-small/Makefile ===
-include ../../run-make-fulldeps/tools.mk

ifeq ($(TARGET),wasm32-unknown-unknown)
all:
	$(RUSTC) foo.rs -C lto -O --target wasm32-unknown-unknown
	wc -c < $(TMPDIR)/foo.wasm
	[ "`wc -c < $(TMPDIR)/foo.wasm`" -lt "20500" ]
else
all:
endif

## rustc 1.41.1+dfsg1

=== src/test/run-make-fulldeps/alloc-extern-crates/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) fakealloc.rs
	$(RUSTC) --edition=2018 --crate-type=rlib ../../../liballoc/lib.rs --cfg feature=\"external_crate\" --extern external=$(TMPDIR)/$(shell $(RUSTC) --print file-names fakealloc.rs)

=== src/test/run-make-fulldeps/codegen-options-parsing/Makefile ===
-include ../tools.mk

all:
	#Option taking a number
	$(RUSTC) -C codegen-units dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `codegen-units` requires a number'
	$(RUSTC) -C codegen-units= dummy.rs 2>&1 | \
		$(CGREP) 'incorrect value `` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=foo dummy.rs 2>&1 | \
		$(CGREP) 'incorrect value `foo` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=1 dummy.rs
	#Option taking a string
	$(RUSTC) -C extra-filename dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `extra-filename` requires a string'
	$(RUSTC) -C extra-filename= dummy.rs 2>&1
	$(RUSTC) -C extra-filename=foo dummy.rs 2>&1
	#Option taking no argument
	$(RUSTC) -C lto= dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto=1 dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto=foo dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto dummy.rs

	# Should not link dead code...
	$(RUSTC) -Z print-link-args dummy.rs 2>&1 | \
		$(CGREP) -e '--gc-sections|-z[^ ]* [^ ]*<ignore>|-dead_strip|/OPT:REF'
	# ... unless you specifically ask to keep it
	$(RUSTC) -Z print-link-args -C link-dead-code dummy.rs 2>&1 | \
		$(CGREP) -ve '--gc-sections|-z[^ ]* [^ ]*<ignore>|-dead_strip|/OPT:REF'

=== src/test/run-make-fulldeps/compiler-rt-works-on-mingw/Makefile ===
-include ../tools.mk

# only-mingw

all:
	$(CXX) foo.cpp -c -o $(TMPDIR)/foo.o
	$(AR) crus $(TMPDIR)/libfoo.a $(TMPDIR)/foo.o
	$(RUSTC) foo.rs -lfoo -lstdc++
	$(call RUN,foo)

=== src/test/run-make-fulldeps/cross-lang-lto-clang/Makefile ===
# needs-matching-clang

# This test makes sure that cross-language inlining actually works by checking
# the generated machine code.

-include ../tools.mk

all: cpp-executable rust-executable

cpp-executable:
	$(RUSTC) -Clinker-plugin-lto=on -o $(TMPDIR)/librustlib-xlto.a -Copt-level=2 -Ccodegen-units=1 ./rustlib.rs
	$(CLANG) -flto=thin -fuse-ld=lld -L $(TMPDIR) -lrustlib-xlto -o $(TMPDIR)/cmain ./cmain.c -O3
	# Make sure we don't find a call instruction to the function we expect to
	# always be inlined.
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/cmain | $(CGREP) -v -e "call.*rust_always_inlined"
	# As a sanity check, make sure we do find a call instruction to a
	# non-inlined function
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/cmain | $(CGREP) -e "call.*rust_never_inlined"

rust-executable:
	$(CLANG) ./clib.c -flto=thin -c -o $(TMPDIR)/clib.o -O2
	(cd $(TMPDIR); $(AR) crus ./libxyz.a ./clib.o)
	$(RUSTC) -Clinker-plugin-lto=on -L$(TMPDIR) -Copt-level=2 -Clinker=$(CLANG) -Clink-arg=-fuse-ld=lld ./main.rs -o $(TMPDIR)/rsmain
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/rsmain | $(CGREP) -e "call.*c_never_inlined"
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/rsmain | $(CGREP) -v -e "call.*c_always_inlined"

=== src/test/run-make-fulldeps/cross-lang-lto-pgo-smoketest/Makefile ===
# needs-matching-clang

# This test makes sure that cross-language inlining can be used in conjunction
# with profile-guided optimization. The test only tests that the whole workflow
# can be executed without anything crashing. It does not test whether PGO or
# xLTO have any specific effect on the generated code.

-include ../tools.mk

COMMON_FLAGS=-Copt-level=3 -Ccodegen-units=1

# LLVM doesn't support instrumenting binaries that use SEH:
# https://bugs.llvm.org/show_bug.cgi?id=41279
#
# Things work fine with -Cpanic=abort though.
ifdef IS_MSVC
COMMON_FLAGS+= -Cpanic=abort
endif

all: cpp-executable rust-executable

cpp-executable:
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-generate="$(TMPDIR)"/cpp-profdata \
	         -o "$(TMPDIR)"/librustlib-xlto.a \
	         $(COMMON_FLAGS) \
	         ./rustlib.rs
	$(CLANG) -flto=thin \
	         -fprofile-generate="$(TMPDIR)"/cpp-profdata \
	         -fuse-ld=lld \
	         -L "$(TMPDIR)" \
	         -lrustlib-xlto \
	         -o "$(TMPDIR)"/cmain \
	         -O3 \
	         ./cmain.c
	$(TMPDIR)/cmain
	# Postprocess the profiling data so it can be used by the compiler
	"$(LLVM_BIN_DIR)"/llvm-profdata merge \
		-o "$(TMPDIR)"/cpp-profdata/merged.profdata \
		"$(TMPDIR)"/cpp-profdata/default_*.profraw
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-use="$(TMPDIR)"/cpp-profdata/merged.profdata \
	         -o "$(TMPDIR)"/librustlib-xlto.a \
	         $(COMMON_FLAGS) \
	         ./rustlib.rs
	$(CLANG) -flto=thin \
	         -fprofile-use="$(TMPDIR)"/cpp-profdata/merged.profdata \
	         -fuse-ld=lld \
	         -L "$(TMPDIR)" \
	         -lrustlib-xlto \
	         -o "$(TMPDIR)"/cmain \
	         -O3 \
	         ./cmain.c

rust-executable:
	exit
	$(CLANG) ./clib.c -fprofile-generate="$(TMPDIR)"/rs-profdata -flto=thin -c -o $(TMPDIR)/clib.o -O3
	(cd $(TMPDIR); $(AR) crus ./libxyz.a ./clib.o)
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-generate="$(TMPDIR)"/rs-profdata \
	         -L$(TMPDIR) \
	         $(COMMON_FLAGS) \
	         -Clinker=$(CLANG) \
	         -Clink-arg=-fuse-ld=lld \
	         -o $(TMPDIR)/rsmain \
	         ./main.rs
	$(TMPDIR)/rsmain
	# Postprocess the profiling data so it can be used by the compiler
	"$(LLVM_BIN_DIR)"/llvm-profdata merge \
		-o "$(TMPDIR)"/rs-profdata/merged.profdata \
		"$(TMPDIR)"/rs-profdata/default_*.profraw
	$(CLANG) ./clib.c \
	         -fprofile-use="$(TMPDIR)"/rs-profdata/merged.profdata \
	         -flto=thin \
	         -c \
	         -o $(TMPDIR)/clib.o \
	         -O3
	rm "$(TMPDIR)"/libxyz.a
	(cd $(TMPDIR); $(AR) crus ./libxyz.a ./clib.o)
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-use="$(TMPDIR)"/rs-profdata/merged.profdata \
	         -L$(TMPDIR) \
	         $(COMMON_FLAGS) \
	         -Clinker=$(CLANG) \
	         -Clink-arg=-fuse-ld=lld \
	         -o $(TMPDIR)/rsmain \
	         ./main.rs

=== src/test/run-make-fulldeps/cross-lang-lto-upstream-rlibs/Makefile ===
-include ../tools.mk

# ignore windows due to libLLVM being present in PATH and the PATH and library path being the same
# (so fixing it is harder). See #57765 for context
ifndef IS_WINDOWS

# This test makes sure that we don't loose upstream object files when compiling
# staticlibs with -C linker-plugin-lto

all: staticlib.rs upstream.rs
	$(RUSTC) upstream.rs -C linker-plugin-lto -Ccodegen-units=1

	# Check No LTO
	$(RUSTC) staticlib.rs -C linker-plugin-lto -Ccodegen-units=1 -L. -o $(TMPDIR)/staticlib.a
	(cd $(TMPDIR); "$(LLVM_BIN_DIR)"/llvm-ar x ./staticlib.a)
	# Make sure the upstream object file was included
	ls $(TMPDIR)/upstream.*.rcgu.o

	# Cleanup
	rm $(TMPDIR)/*

	# Check ThinLTO
	$(RUSTC) upstream.rs -C linker-plugin-lto -Ccodegen-units=1 -Clto=thin
	$(RUSTC) staticlib.rs -C linker-plugin-lto -Ccodegen-units=1 -Clto=thin -L. -o $(TMPDIR)/staticlib.a
	(cd $(TMPDIR); "$(LLVM_BIN_DIR)"/llvm-ar x ./staticlib.a)
	ls $(TMPDIR)/upstream.*.rcgu.o

else

all:

endif

=== src/test/run-make-fulldeps/emit/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) -Copt-level=0 --emit=llvm-bc,llvm-ir,asm,obj,link test-24876.rs
	$(RUSTC) -Copt-level=1 --emit=llvm-bc,llvm-ir,asm,obj,link test-24876.rs
	$(RUSTC) -Copt-level=2 --emit=llvm-bc,llvm-ir,asm,obj,link test-24876.rs
	$(RUSTC) -Copt-level=3 --emit=llvm-bc,llvm-ir,asm,obj,link test-24876.rs
	$(RUSTC) -Copt-level=s --emit=llvm-bc,llvm-ir,asm,obj,link test-24876.rs
	$(RUSTC) -Copt-level=z --emit=llvm-bc,llvm-ir,asm,obj,link test-24876.rs
	$(RUSTC) -Copt-level=0 --emit=llvm-bc,llvm-ir,asm,obj,link test-26235.rs
	$(call RUN,test-26235) || exit 1
	$(RUSTC) -Copt-level=1 --emit=llvm-bc,llvm-ir,asm,obj,link test-26235.rs
	$(call RUN,test-26235) || exit 1
	$(RUSTC) -Copt-level=2 --emit=llvm-bc,llvm-ir,asm,obj,link test-26235.rs
	$(call RUN,test-26235) || exit 1
	$(RUSTC) -Copt-level=3 --emit=llvm-bc,llvm-ir,asm,obj,link test-26235.rs
	$(call RUN,test-26235) || exit 1
	$(RUSTC) -Copt-level=s --emit=llvm-bc,llvm-ir,asm,obj,link test-26235.rs
	$(call RUN,test-26235) || exit 1
	$(RUSTC) -Copt-level=z --emit=llvm-bc,llvm-ir,asm,obj,link test-26235.rs
	$(call RUN,test-26235) || exit 1

=== src/test/run-make-fulldeps/extern-fn-reachable/Makefile ===
-include ../tools.mk

# This overrides the LD_LIBRARY_PATH for RUN
TARGET_RPATH_DIR:=$(TARGET_RPATH_DIR):$(TMPDIR)

all:
	$(RUSTC) dylib.rs -o $(TMPDIR)/libdylib.so -C prefer-dynamic
	$(RUSTC) main.rs -C prefer-dynamic
	$(call RUN,main)

=== src/test/run-make-fulldeps/include_bytes_deps/Makefile ===
-include ../tools.mk

# ignore-windows
# ignore-freebsd
# FIXME: on windows `rustc --dep-info` produces Makefile dependency with
# windows native paths (e.g. `c:\path\to\libfoo.a`)
# but msys make seems to fail to recognize such paths, so test fails.

all:
	$(RUSTC) --emit dep-info main.rs
	$(CGREP) "input.txt" "input.bin" "input.md" < $(TMPDIR)/main.d

=== src/test/run-make-fulldeps/intrinsic-unreachable/Makefile ===
-include ../tools.mk

# ignore-windows
#
# Because of Windows exception handling, the code is not necessarily any shorter.
# https://github.com/llvm-mirror/llvm/commit/64b2297786f7fd6f5fa24cdd4db0298fbf211466

all:
	$(RUSTC) -O --emit asm exit-ret.rs
	$(RUSTC) -O --emit asm exit-unreachable.rs
	test `wc -l < $(TMPDIR)/exit-unreachable.s` -lt `wc -l < $(TMPDIR)/exit-ret.s`

=== src/test/run-make-fulldeps/lto-smoke/Makefile ===
-include ../tools.mk

all: noparam bool_true bool_false thin fat

noparam:
	$(RUSTC) lib.rs
	$(RUSTC) main.rs -C lto
	$(call RUN,main)

bool_true:
	$(RUSTC) lib.rs
	$(RUSTC) main.rs -C lto=yes
	$(call RUN,main)


bool_false:
	$(RUSTC) lib.rs
	$(RUSTC) main.rs -C lto=off
	$(call RUN,main)

thin:
	$(RUSTC) lib.rs
	$(RUSTC) main.rs -C lto=thin
	$(call RUN,main)

fat:
	$(RUSTC) lib.rs
	$(RUSTC) main.rs -C lto=fat
	$(call RUN,main)

=== src/test/run-make-fulldeps/mismatching-target-triples/Makefile ===
-include ../tools.mk

# Issue #10814
#
# these are no_std to avoid having to have the standard library or any
# linkers/assemblers for the relevant platform

all:
	$(RUSTC) foo.rs --target=i686-unknown-linux-gnu
	$(RUSTC) bar.rs --target=x86_64-unknown-linux-gnu 2>&1 \
		| $(CGREP) 'couldn'"'"'t find crate `foo` with expected target triple x86_64-unknown-linux-gnu'

=== debian/changelog ===
rustc (1.41.1+dfsg1-1~deb10u1.lnd.4+b1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild

 -- root <root@loongson-pc>  Fri, 01 Apr 2022 16:38:00 +0800

rustc (1.41.1+dfsg1-1~deb10u1.lnd.4+b1) unstable; urgency=medium

  * rebuild

 -- root  <zhaixiaojuan@loongson.cn>  Thu, 10 Feb 2022 10:49:14 +0800

rustc (1.41.1+dfsg1-1~deb10u1.lnd.4) unstable; urgency=medium

  * update_gs464_to_la464.patch
  * add_loongarch_target_feature.patch
  * This version is consistent with lnd.3 and is only used to solve the version conflict problem of gerritos when building

 -- zhaixiaojuan <zhaixiaojuan@loongson.cn>  Thu, 10 Feb 2022 10:49:14 +0800

rustc (1.41.1+dfsg1-1~deb10u1.lnd.3) unstable; urgency=medium
  
  * update_gs464_to_la464.patch
  * add_loongarch_target_feature.patch

 -- zhaixiaojuan <zhaixiaojuan@loongson.cn>  Wed, 26 Jan 2021 10:49:14 +0800

rustc (1.41.1+dfsg1-1~deb10u1.lnd.2) unstable; urgency=medium

  * l-rustc-loongarch-newabi.patch
  * loongarch64 new abi, and fix some type define

 -- wanglei <wanglei@loongson.cn>  Wed, 27 Jan 2021 20:37:14 +0800

rustc (1.41.1+dfsg1-1~deb10u1.lnd.1) unstable; urgency=medium

  * cc-add-loongarch-support.patch
  * libc-add-loongarch-support.patch
  * rustc-add-loongarch-support.patch
  * l-fix-type-define-on-loongarch64.patch

 -- wanglei <wanglei@loongson.cn>  Fri, 15 Jan 2021 11:06:19 +0800

rustc (1.41.1+dfsg1-1~deb10u1) buster; urgency=medium

  * Non-maintainer upload.
  * Backport to buster.
  * stage0 build.
    - Use arm-unknown-linux-gnueabi target for armel.
  * Use LLVM 7.
  * Disable wasm.
  * Reduce debugging symbols on i386 to avoid FTBFS due to OOM.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Tue, 08 Sep 2020 18:38:19 +0200

rustc (1.41.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Fri, 03 Apr 2020 23:41:11 +0100

rustc (1.41.1+dfsg1-1~exp1) experimental; urgency=medium

  [ Ximin Luo ]
  * More python 2 -> 3 fixes.
  * Enable the wasm32-wasi target for code that needs a "real" libstd.
  * Don't strip static rlibs. This sometimes breaks wasm, and more generally
    the stripped debuginfo is actually totally lost rather than being moved
    into the -dbgsym packages. Shared libraries are unaffected and work.
  * Allow 180 failing tests on riscv64, none were actually run last time.

  [ Fabian Grünbichler ]
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 09 Mar 2020 00:31:34 +0000

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.14),
               python3:native,
               cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
#               rustc:native (>= 1.40.0+dfsg) <!pkg.rustc.dlstage0>,
               rustc:native,
               llvm-8-dev:native,
               llvm-8-tools:native,
#               libllvm7 (>= 1:9.0.1-2),
               autotools-dev,
#               cmake (>= 3.0) | cmake3,
# needed by some vendor crates
               pkg-config,
# this is sometimes needed by rustc_llvm
               zlib1g-dev:native,
               zlib1g-dev,
# used by rust-installer
               liblzma-dev:native,
# test dependencies:
               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
               git <!nocheck>,
               procps <!nocheck>,
# below are optional tools even for 'make check'
#               gdb (>= 7.12) <!nocheck>,
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
               curl <pkg.rustc.dlstage0>,
               ca-certificates <pkg.rustc.dlstage0>,
#Build-Depends-Indep:
# wasi-libc (>= 0.0~git20191220.a280fea~~) <!nowasm>,
# wasi-libc (<= 0.0~git20191220.a280fea++) <!nowasm>,
Build-Conflicts: gdb-minimal <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends: cargo (>= 0.42.0~~), cargo (<< 0.43.0~~), rust-gdb | rust-lldb
Suggests: rust-doc, rust-src, lld-7
Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.41
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.41 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

#Package: libstd-rust-dev-wasm32-cross
#Section: libdevel
#Architecture: all
#Depends: ${shlibs:Depends}, ${misc:Depends}, lld-7
## Embeds wasi-libc so doesn't need to depend on it
## None of its licenses require source redistrib, so no need for Built-Using
#Build-Profiles: <!nowasm>
#Description: Rust standard libraries - development files
# Rust is a curly-brace, block-structured expression language.  It
# visually resembles the C language family, but differs significantly
# in syntactic and semantic details.  Its design is oriented toward
# concerns of "programming in the large", that is, of creating and
# maintaining boundaries - both abstract and operational - that
# preserve large-system integrity, availability and concurrency.
# .
# It supports a mixture of imperative procedural, concurrent actor,
# object-oriented and pure functional styles.  Rust also supports
# generic programming and meta-programming, in both static and dynamic
# styles.
# .
# This package contains development files necessary to use the standard
# Rust libraries, for cross-compiling to the wasm32-unknown-unknown target.

Package: rust-gdb
Architecture: all
Depends: binutils, ${misc:Depends}
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
#lldb-7, python3-lldb-7 are not currently on the loongarch-debian-system, so temporaaily delete them
#Depends: lldb-7, ${misc:Depends}, python3-lldb-7
Depends: ${misc:Depends}
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome
Recommends: cargo-doc
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-src
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
RUSTFLAGS += --cap-lints warn --remap-path-prefix=$(CURDIR)=/usr/src/rustc-$(RUST_LONG_VERSION)
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo
ifneq (,$(filter $(DEB_BUILD_ARCH), sparc64))
export CARGO_INCREMENTAL = 0
endif

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 8
OLD_LLVM_VERSION = 9
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py
RUSTBUILD_FLAGS = --config debian/config.toml -vvv --on-fail env
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

#BUILD_WASM := true
BUILD_WASM := false
ifneq (,$(findstring nowasm,$(DEB_BUILD_PROFILES)))
  BUILD_WASM := false
endif

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Workaround for linux #865549
ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
endif
# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; echo $$channel; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe))
	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
endif

debian/rust-src.%: debian/rust-src.%.in
	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
		"$<" > "$@"

debian/dh_auto_configure.stamp: debian/config.toml
	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	#! grep --color=always -i 'll\(..\|d\)-\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog --exclude='*.patch' --exclude-dir='.debhelper' -R debian
	# fail the build if we accidentally vendored openssl, indicates we pulled in unnecessary dependencies
	test ! -e vendor/openssl
	# fail the build if we didn't update d-ignore-error-detail-diff.patch
	! grep -Ri '\$$SRC_DIR' src/test/
	# fail the build if our version contains ~exp and we are not releasing to experimental
	v="$(DEB_VERSION)"; test "$$v" = "$${v%~exp*}" -o "$(DEB_DISTRIBUTION)" = "experimental" -o "$(DEB_DISTRIBUTION)" = "UNRELEASED"
	$(PRECONFIGURE_CHECK)
	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
	# work around #842634

## rustc 1.42.0+dfsg1

=== debian/changelog ===
rustc (1.42.0+dfsg1-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.
  [changes introduced in 1.42.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Use the compiler itself rather than dpkg to detect DEB_BUILD_RUST_TYPE

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 25 Apr 2020 04:53:04 +0000

rustc (1.42.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Fri, 10 Apr 2020 11:33:25 +0100

rustc (1.42.0+dfsg1-1~exp1) experimental; urgency=medium

  [ Fabian Grünbichler ]
  * Team upload.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Apr 2020 16:06:03 +0100

=== debian/control ===
--- 
+++ 
@@ -7,16 +7,17 @@
  Sylvestre Ledru <sylvestre@debian.org>
 # :native annotations are to support cross-compiling, see README.Debian
 Build-Depends: debhelper (>= 9),
+               debhelper-compat (= 12),
                dpkg-dev (>= 1.17.14),
                python3:native,
                cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
-#               rustc:native (>= 1.40.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native,
-               llvm-8-dev:native,
-               llvm-8-tools:native,
-#               libllvm7 (>= 1:9.0.1-2),
+               rustc:native (>= 1.41.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.42.0++)    <!pkg.rustc.dlstage0>,
+               llvm-9-dev:native,
+               llvm-9-tools:native,
+               libllvm9 (>= 1:9.0.1-2),
                autotools-dev,
-#               cmake (>= 3.0) | cmake3,
+               cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
                pkg-config,
 # this is sometimes needed by rustc_llvm
@@ -29,13 +30,13 @@
                git <!nocheck>,
                procps <!nocheck>,
 # below are optional tools even for 'make check'
-#               gdb (>= 7.12) <!nocheck>,
+               gdb (>= 7.12) <!nocheck>,
 # Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
                curl <pkg.rustc.dlstage0>,
                ca-certificates <pkg.rustc.dlstage0>,
-#Build-Depends-Indep:
-# wasi-libc (>= 0.0~git20191220.a280fea~~) <!nowasm>,
-# wasi-libc (<= 0.0~git20191220.a280fea++) <!nowasm>,
+Build-Depends-Indep:
+ wasi-libc (>= 0.0~git20200114.1fad338~~) <!nowasm>,
+ wasi-libc (<= 0.0~git20200114.1fad338++) <!nowasm>,
 Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 4.2.1
 Homepage: http://www.rust-lang.org/
@@ -48,8 +49,8 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: cargo (>= 0.42.0~~), cargo (<< 0.43.0~~), rust-gdb | rust-lldb
-Suggests: rust-doc, rust-src, lld-7
+Recommends: cargo (>= 0.43.0~~), cargo (<< 0.44.0~~), rust-gdb | rust-lldb
+Suggests: rust-doc, rust-src, lld-9
 Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Description: Rust systems programming language
@@ -65,7 +66,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.41
+Package: libstd-rust-1.42
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -90,7 +91,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.41 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.42 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -107,32 +108,33 @@
  This package contains development files necessary to use the standard
  Rust libraries.
 
-#Package: libstd-rust-dev-wasm32-cross
-#Section: libdevel
-#Architecture: all
-#Depends: ${shlibs:Depends}, ${misc:Depends}, lld-7
-## Embeds wasi-libc so doesn't need to depend on it
-## None of its licenses require source redistrib, so no need for Built-Using
-#Build-Profiles: <!nowasm>
-#Description: Rust standard libraries - development files
-# Rust is a curly-brace, block-structured expression language.  It
-# visually resembles the C language family, but differs significantly
-# in syntactic and semantic details.  Its design is oriented toward
-# concerns of "programming in the large", that is, of creating and
-# maintaining boundaries - both abstract and operational - that
-# preserve large-system integrity, availability and concurrency.
-# .
-# It supports a mixture of imperative procedural, concurrent actor,
-# object-oriented and pure functional styles.  Rust also supports
-# generic programming and meta-programming, in both static and dynamic
-# styles.
-# .
-# This package contains development files necessary to use the standard
-# Rust libraries, for cross-compiling to the wasm32-unknown-unknown target.
+Package: libstd-rust-dev-wasm32-cross
+Section: libdevel
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, lld-9
+# Embeds wasi-libc so doesn't need to depend on it
+# None of its licenses require source redistrib, so no need for Built-Using
+Build-Profiles: <!nowasm>
+Description: Rust standard libraries - development files
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains development files necessary to use the standard
+ Rust libraries, for cross-compiling to the wasm32-unknown-unknown target.
 
 Package: rust-gdb
 Architecture: all
-Depends: binutils, ${misc:Depends}
+Depends: gdb, ${misc:Depends}
+Suggests: gdb-doc
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (gdb)
  Rust is a curly-brace, block-structured expression language.  It
@@ -153,9 +155,7 @@
 Package: rust-lldb
 Architecture: all
 # When updating, also update rust-lldb.links
-#lldb-7, python3-lldb-7 are not currently on the loongarch-debian-system, so temporaaily delete them
-#Depends: lldb-7, ${misc:Depends}, python3-lldb-7
-Depends: ${misc:Depends}
+Depends: lldb-9, ${misc:Depends}, python3-lldb-9
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It

=== debian/rules ===
--- 
+++ 
@@ -33,8 +33,8 @@
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
 # Use system LLVM (comment out to use vendored LLVM)
-LLVM_VERSION = 8
-OLD_LLVM_VERSION = 9
+LLVM_VERSION = 9
+OLD_LLVM_VERSION = 8
 # Make it easier to test against a custom LLVM
 ifneq (,$(LLVM_DESTDIR))
 LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
@@ -112,8 +112,7 @@
   BUILD_DOCS := false
 endif
 
-#BUILD_WASM := true
-BUILD_WASM := false
+BUILD_WASM := true
 ifneq (,$(findstring nowasm,$(DEB_BUILD_PROFILES)))
   BUILD_WASM := false
 endif
@@ -166,7 +165,7 @@
 	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
 	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 # Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
-ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe))
+ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel mips mipsel powerpc powerpcspe))
 	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
 endif
 
@@ -176,7 +175,7 @@
 
 debian/dh_auto_configure.stamp: debian/config.toml
 	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
-	#! grep --color=always -i 'll\(..\|d\)-\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog --exclude='*.patch' --exclude-dir='.debhelper' -R debian
+	! grep --color=always -i 'll\(..\|d\)-\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog --exclude='*.patch' --exclude-dir='.debhelper' -R debian
 	# fail the build if we accidentally vendored openssl, indicates we pulled in unnecessary dependencies
 	test ! -e vendor/openssl
 	# fail the build if we didn't update d-ignore-error-detail-diff.patch

## rustc 1.43.0+dfsg1

=== debian/changelog ===
rustc (1.43.0+dfsg1-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.
  [changes introduced in 1.42.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Use the compiler itself rather than dpkg to detect DEB_BUILD_RUST_TYPE

 -- Raspbian forward porter <root@raspbian.org>  Fri, 17 Jul 2020 17:43:38 +0000

rustc (1.43.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Bump LLVM B-D version for some backported fixes affecting rustc.

 -- Ximin Luo <infinity0@debian.org>  Sun, 05 Jul 2020 15:06:52 +0100

rustc (1.43.0+dfsg1-1~exp1) experimental; urgency=medium

  * Drop sparc64 workaround. (Closes: #956413)
  * Drop stack-gap workaround for old kernels and rust versions.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 27 Apr 2020 13:09:20 +0100

=== debian/control ===
--- 
+++ 
@@ -11,12 +11,11 @@
                dpkg-dev (>= 1.17.14),
                python3:native,
                cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
-               rustc:native (>= 1.41.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native (<= 1.42.0++)    <!pkg.rustc.dlstage0>,
+               rustc:native (>= 1.42.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.43.0++)    <!pkg.rustc.dlstage0>,
                llvm-9-dev:native,
                llvm-9-tools:native,
-               libllvm9 (>= 1:9.0.1-2),
-               autotools-dev,
+               libllvm9 (>= 1:9.0.1-13),
                cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
                pkg-config,
@@ -49,7 +48,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: cargo (>= 0.43.0~~), cargo (<< 0.44.0~~), rust-gdb | rust-lldb
+Recommends: cargo (>= 0.44.0~~), cargo (<< 0.45.0~~), rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src, lld-9
 Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
@@ -66,7 +65,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.42
+Package: libstd-rust-1.43
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -91,7 +90,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.42 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.43 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly

=== debian/rules ===
--- 
+++ 
@@ -19,9 +19,6 @@
 RUSTFLAGS += --cap-lints warn --remap-path-prefix=$(CURDIR)=/usr/src/rustc-$(RUST_LONG_VERSION)
 export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
 export CARGO_HOME = $(CURDIR)/debian/cargo
-ifneq (,$(filter $(DEB_BUILD_ARCH), sparc64))
-export CARGO_INCREMENTAL = 0
-endif
 
 # Defines DEB_*_RUST_TYPE triples
 include debian/architecture.mk
@@ -126,10 +123,6 @@
 SRC_CLEAN = src/bootstrap/bootstrap.pyc \
 	src/etc/__pycache__/
 
-# Workaround for linux #865549
-ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
-  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
-endif
 # Try to work around #933045
 ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
   SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
@@ -185,3 +178,8 @@
 	$(PRECONFIGURE_CHECK)
 	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
 	# work around #842634
+	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
+	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
+	# work around https://github.com/rust-lang/rust/issues/59264
+	# We patched some crates so have to rm the checksums
+	find vendor -name .cargo-checksum.json -execdir "$(CURDIR)/debian/prune-checksums" "{}" +
